#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "GameplayTagContainer.h"
#include "FogVialCosmeticHelperActor.generated.h"

class ADBDPlayer;

UCLASS(Blueprintable, Abstract)
class DBDSURVIVORCOLLECTABLES_API AFogVialCosmeticHelperActor : public AActor
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FGameplayTagContainer _stateTagsToPreventShowAura;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FGameplayTagContainer _stateTagsPreventShowFog;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _fogOpacityNeededForSelfAura;

private:
	UFUNCTION(BlueprintCallable)
	void OnFirstPersonChanged(bool isFirstPerson);

	UFUNCTION(BlueprintPure)
	ADBDPlayer* GetOwningPlayer() const;

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_UpdateVisibility(bool isVisible);

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnFogStarted();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnFogEnded();

public:
	AFogVialCosmeticHelperActor();
};

FORCEINLINE uint32 GetTypeHash(const AFogVialCosmeticHelperActor) { return 0; }
